package vc.thinker.absctacts.protocolproxy.dto;

import lombok.Getter;
import vc.thinker.absctacts.protocolproxy.enums.ServiceExecuteResultType;

/**
 * 服务执行结果
 *
 * @author HeTongHao
 * @since 2021/8/11 17:47
 */
@Getter
public class ServiceExecuteResult implements IServiceExecuteResult {
    private ServiceExecuteResult(String requestId, ServiceExecuteResultType type, String message) {
        this.requestId = requestId;
        this.type = type;
        this.message = message;
    }

    private final String requestId;
    private final ServiceExecuteResultType type;
    private final String message;

    public static ServiceExecuteResult ok(IServiceExecuteCmd cmd) {
        return new ServiceExecuteResult(cmd.getRequestId(), ServiceExecuteResultType.ok, ServiceExecuteResultType.ok.getName());
    }

    public static ServiceExecuteResult fail(IServiceExecuteCmd cmd) {
        return new ServiceExecuteResult(cmd.getRequestId(), ServiceExecuteResultType.fail, ServiceExecuteResultType.fail.getName());
    }

    public static ServiceExecuteResult fail(IServiceExecuteCmd cmd, String message) {
        return new ServiceExecuteResult(cmd.getRequestId(), ServiceExecuteResultType.fail, message);
    }
}
